/****************************************************************************
 **
 ** Author: Grigory A. Mozhaev
 ** Copyright (C) 2008-2009 Griland Company.
 ** Contact: Griland Company (griland.support@gmail.com)
 **
 ** This file may be used under the terms of the GNU General Public
 ** License version 2.0 as published by the Free Software Foundation
 ** and appearing in the file LICENSE.GPL included in the packaging of
 ** this file.  Please review the following information to ensure GNU
 ** General Public Licensing requirements will be met:
 ** http://www.trolltech.com/products/qt/opensource.html
 **
 ** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 ** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 **
 ****************************************************************************/
#ifndef _CMAINWINDOW_H_
#define _CMAINWINDOW_H_

#include <Qt/QtCore>
#include <Qt/QtGui>

#include "cdvdmodel.h"
#include "cgeneratedialog.h"

class CMainWindow : public QMainWindow {
Q_OBJECT

public:
    CMainWindow(QWidget *apParent = 0,  Qt::WFlags aFlags = 0);
    ~CMainWindow();

protected:
    void closeEvent(QCloseEvent *apEvent);

private:
    int createDvdPlaces();
    void checkMd5SumFiles();

public slots:
    int init();
    void refreshRootDirsSlot();

private:
    CGenerateDialog *mpGenerateDialog;
};

#endif // _CMAINWINDOW_H_
