/****************************************************************************
 **
 ** Author: Grigory A. Mozhaev
 ** Copyright (C) 2008-2009 Griland Company.
 ** Contact: Griland Company (griland.support@gmail.com)
 **
 ** This file may be used under the terms of the GNU General Public
 ** License version 2.0 as published by the Free Software Foundation
 ** and appearing in the file LICENSE.GPL included in the packaging of
 ** this file.  Please review the following information to ensure GNU
 ** General Public Licensing requirements will be met:
 ** http://www.trolltech.com/products/qt/opensource.html
 **
 ** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 ** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 **
 ****************************************************************************/
#ifndef _CSELECTDIALOG_H_
#define _CSELECTDIALOG_H_

#include <Qt/QtGui>

namespace Ui {
    class CSelectDialog;
}

class CSelectDialog : public QDialog {
Q_OBJECT

public:
    CSelectDialog(QWidget * apParent = 0, Qt::WindowFlags aFlags = 0);
    virtual ~CSelectDialog();

    void init(const QStringList& aList);    
    bool isChecked(const QString &aItemName);

private:
    int mCheckedCount;
    Ui::CSelectDialog* mpUi;

    void canContinue();

private slots:
    void on_mpListWidget_itemChanged(QListWidgetItem *);

};

#endif /* _CSELECTDIALOG_H_ */
